;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;	An Iterative Function System (IFS) Fractal - "The Fern"
;	(Assemble with nasm.)
;
;	Translated from masm version originally written by Ron Thomas (Ron_Thom@Compuserve.com)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

%include "nagoa+.inc"

%macro LOWORD 1
	mov	eax,%1
	and	eax,0FFFFh	;; Set to low word 
%endmacro

%macro HIWORD 1
	mov	eax,%1
	shr	eax,16		;; Shift 16 for high word to set to high word
%endmacro

;%macro API 2                                   ;Function , Library
;	extern %1
;	import %1 %2
;%endmacro

API GetModuleHandleA, kernel32.dll
API GetCommandLineA,kernel32.dll
API ExitProcess, kernel32.dll
API LoadIconA,user32.dll
API LoadCursorA,user32.dll
API CreateWindowExA, user32.dll
API ShowWindow,user32.dll
API UpdateWindow,user32.dll
API GetMessageA, user32.dll
API DispatchMessageA, user32.dll
API TranslateMessage,user32.dll
API BeginPaint,user32.dll
API SetPixel,gdi32.dll
API EndPaint,user32.dll
API PostQuitMessage,user32.dll
API DefWindowProcA, user32.dll
API MessageBoxA, user32.dll
API RegisterClassExA, user32.dll

segment .data USE32
CommandLine	dd 0
Windowhandle            	dd 0
Instance        	dd 0
Windowclassname db "OurWindowclass",0
Windowname db "fern",0
OurWindowclass:	
istruc WNDCLASSEX
	at WNDCLASSEX.cbSize,		dd WNDCLASSEX_size
	at WNDCLASSEX.style,		dd CS_HREDRAW|CS_VREDRAW
	at WNDCLASSEX.lpfnWndProc,	dd WindowProc
	at WNDCLASSEX.hbrBackground,	dd COLOR_WINDOW+1
	at WNDCLASSEX.lpszClassName,	dd Windowclassname
iend

cxClient	dd	0
cyClient	dd	0
colour		dd	0
p		dd	328, 2621, 4915		; Probability weightings
limit		dd	250000			; 250000	
j		dd	0
scaleX		dd	0			; Scaling
scaleY		dd	0
x_offset	dd	0			; Screen Offsets
y_offset	dd	0
xx		dd	0			; Coordinates of point to be plotted
yy		dd	0

random_init	dd	1010111000110111101010011011b	; Seed for random number

a		dd	0.0,  0.20, -0.15,  0.85
b		dd	0.0, -0.26,  0.28,  0.04
c		dd	0.0,  0.23,  0.26, -0.04
d		dd	0.16, 0.22,  0.24,  0.85
e		dd	0.0,  0.0,   0.0,   0.0
f		dd	0.0,  1.60,  0.44,  1.6
x		dd	0.0
y		dd	0.0

segment .bss USE32
MessageBuffer resb MSG_size

segment .code USE32
..start:
	call GetModuleHandleA, 0
	mov dword [Instance], eax
	call GetCommandLineA
	mov dword [CommandLine], eax
	
	loccall WinMain, [Instance], NULL, eax, SW_SHOW
	call ExitProcess, eax

proc WinMain, hInstance, hPrevInstance, lpCmdLine, nCmdShow
 	mov eax, dword [Instance]
        mov dword [OurWindowclass+WNDCLASSEX.hInstance], eax
        call LoadIconA, NULL, IDI_APPLICATION
        mov dword [OurWindowclass+WNDCLASSEX.hIcon], eax
        mov dword [OurWindowclass+WNDCLASSEX.hIconSm], eax
        call LoadCursorA, NULL, IDC_ARROW
        mov dword [OurWindowclass+WNDCLASSEX.hCursor], eax
        call RegisterClassExA,OurWindowclass
        test eax, eax
        jnz .DoAndShow
        return
 
 .DoAndShow:
    
       ;--- create and show the main program window
 	call CreateWindowExA,NULL,Windowclassname,Windowname,WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT, NULL, NULL, [Instance], NULL
 	mov dword [Windowhandle], eax
 	call ShowWindow, [Windowhandle], [@nCmdShow]
 	call UpdateWindow,[Windowhandle]
 
 ; -- every time user moves mouse or imput some msg this loop is activated
 ; -- in order to get all messages imputed by the user 
 .loop
 	call GetMessageA,MessageBuffer, NULL, 0, 0         
 	cmp eax, 0
 	jb .erro
 	je .fin
 	call TranslateMessage,MessageBuffer
 	call DispatchMessageA,MessageBuffer
 	jmp .loop
 .erro:
 	call MessageBoxA, 0, "ERROR", "Sorry ...", MB_OK
 .fin:
 	mov eax, dword[MessageBuffer+MSG.wParam]
endproc

proc WindowProc,hwnd,uMsg,wParam,lParam
	stack hdc,4,ps,PAINTSTRUCT_size
	if dword [@uMsg],e,WM_CREATE
		RGB	100,170,40		; Set pixel plot colour to thick green
		mov	[colour],eax
		return
	endif
	if dword [@uMsg],e,WM_SIZE
		LOWORD  [@lParam]
		mov	[cxClient],eax
		shr	eax,1
		mov	[x_offset],eax		; Compute offset
		mov	ecx,15			; Compute scaling factor
		mov	eax,[cxClient]
		mov	edx,0
		div	ecx
		mov	[scaleX],eax		

		HIWORD  [@lParam]
		mov	[cyClient],eax
		shr	eax,3
		mov	[y_offset],eax
		mov	ecx,12			; Compute scaling factor  		
		mov	eax,[cyClient]
		mov	edx,0
		div	ecx
		mov	[scaleY],eax		
		
		return FALSE
	endif
	if dword [@uMsg],e,WM_PAINT
		call BeginPaint,[@hwnd], ADDR @ps
		mov   [@hdc],eax
		loccall plotpixels,[@hdc]        ;;;;;plot all the pixels and build the fern fractal
		call EndPaint,[@hwnd], ADDR @ps
		return FALSE
	endif
	
	if dword [@uMsg],e,WM_DESTROY
		call PostQuitMessage, 0	
		xor eax,eax
	endif
defaultaction:
	call DefWindowProcA, [@hwnd], [@uMsg], [@wParam], [@lParam]
	return
endproc
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
proc plotpixels,hdc
	mov	esi,0
	while  esi,l,[limit]
		mov		al,16
		loccall	random			; Get random number 16 bits big (in eax)

		if eax,l,[p+0]			; Set k to 0,1,2, or 3 
			mov	ebx,0		;
		elseif	eax,l,[p+4]	
			mov	ebx,1		;
		elseif   eax,l,[p+8]	
			mov	ebx,2		;
		else
			mov	ebx,3		;
		endif

		finit				; Initialise the coprocessor
		shl	  ebx,2			; Form dword index
		fld   dword  [a+ebx]
		fmul  dword[x]			; X.a(k)
		fld	dword [b+ebx]
		fmul  dword[y]			; Y.b(k)
		faddp  st1		
		fadd  dword[e+ebx]		; X.a(k) + Y.b(k) + e(k), x 	

		fld	dword [c+ebx]
		fmul  dword[x]			; X.c(k)
		fld	dword [d+ebx]
		fmul  dword[y]			; Y.d(k)
		faddp  st1
		fadd  dword [f+ebx]		; X.c(k) + Y.d(k) + f(k), x

		fstp 	dword[y]		; Update Y
		fst	 dword[x]	 	; Update X

		fimul	dword[scaleX]		; x*scaleX
		fiadd	dword[x_offset]		; x*scale + xoffset	
		fistp	dword[xx] 
		mov	ecx,dword[xx]

		fld	dword[y]
		fimul	dword[scaleY]		; y*scaleY
		fiadd	dword[y_offset]
		fistp	dword[yy]
		mov	edx,dword[yy]

		;	If pixel is within the screen limits plot it
		ifand ecx,ge,0,ecx,l,[cxClient],edx,ge,0,edx,l,[cyClient]
			call SetPixel,[@hdc], [xx], [yy], [colour] ; Plot the pixel 
		endif
		inc	esi
	wend
endproc
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;-----------------------------------------------;
; Generate Pseudo Random number (Fast)		;
;						;
; Entry:   al = size of random number		;					
;						;
; Return: eax = random number, cl bits in size	;
;-----------------------------------------------;

proc random
	mov	cl,al
	xor	eax,eax
	mov	bl,byte [random_init]
	and	bl,1            
Gen_bit:				; make n bit numbers
	shl	eax,1

	mov	edx,[random_init]	; Copy seed  

	shr	edx,9
	xor	bl,dl

	shr	edx,5
	xor	bl,dl

	bt	ebx,1			; Copy bit 1 to carry flag
	rcr	dword[random_init],1	; Rotate seed right 1 bit

	setc	bl			; Set bl TRUE if carry is set		
	or	al,bl

	dec	cl
	jnz	Gen_bit
endproc

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

